<template>
    <div class="login-container" :style="styleObject">
        <v-container class="fill-height" fluid>
            <v-form @submit.prevent class="custom">
                <v-row justify="center" align="center">
                    <v-col cols="12" sm="8" md="4">
                        <v-card class="login-card" align="center">
                            <v-img src="../assets/images/eureko-logo-blue.png" height="28" width="120"></v-img>
                            <v-card-title class="text-center">MITC'ye Hoş Geldiniz</v-card-title>
                            <v-card-text>
                                <v-col>
                                    <span style="color: #404040;">Kullanıcı Adı</span>
                                    <v-text-field :md="12" :width="100"
                                                  class="text-eureko-login text-eureko"
                                                  v-model="UserName"
                                                  placeholder="Kullanıcı Adı"
                                                  type="text"
                                    ></v-text-field>
                                </v-col>
                                <v-col>
                                    <span style="color: #404040;">Şifre</span>
                                    <v-text-field :md="12" :width="100"
                                                  class="text-eureko-login text-eureko"
                                                  v-model="Password"
                                                  placeholder="Şifre"
                                                  type="password"
                                    ></v-text-field>
                                </v-col>
                            </v-card-text>
                            <v-card-actions style="justify-content: space-around;">
                                <custom-button color="fifth" size="small" val="Şifremi Unuttum"/>
                                <custom-button style="width: 120px;margin-left: 10px" color="primary" size="medium" @click="login"
                                               val="Giriş"/>

                            </v-card-actions>
                        </v-card>
                    </v-col>
                </v-row>
            </v-form>
            <v-snackbar
                v-model="snackbar"
                :timeout="1500"
                absolute
                centered
                color="deep-purple accent-4"
                elevation="24"
            >
                {{ errorMessage }}
            </v-snackbar>
        </v-container>
    </div>
</template>


<script scoped>
import CustomButton from '@/components/custom-controller/CustomButton.vue'
import {AUTH_REQUEST} from '@/store/actions/auth'

export default {
    data() {
        return {
            snackbar: false,
            errorMessage: '',
            valid: true,
            UserName: localStorage.getItem('UserName'),
            Password: '',
            RememberMe: localStorage.getItem('RememberMe') === 'true',
            LoginFailedCount: 0,
            recaptchaToken: '',
            enteredCapctha: '',
            canAddListener: true,
            isActiveKeyup: true,
            previousUserName: '',
            previousPassword: ''
        }
    },
    components: {
        CustomButton
    },
    computed: {
        styleObject() {
            return {
                backgroundImage: 'url(' + require('@/assets/images/login-bg.jpg') + ')',
                backgroundSize: 'cover',
                backgroundPosition: 'center'
            }
        },
    },
    created () {
        localStorage.setItem('LFCount', 0)
        this.setCapcthaToken()
        const mythis = this
        window.addEventListener('keyup', function (event) {
            if (event.key === 'Enter') {
                if (mythis.canAddListener === true) {
                    mythis.login()
                }
            }
        })
    },
    watch: {
        UserName: function (value) {
            if (this.previousUserName === value) {
                this.isActiveKeyup = false
            } else {
                this.isActiveKeyup = true
                this.previousUserName = value
            }
        },
        Password: function (value) {
            if (this.previousPassword === value) {
                this.isActiveKeyup = false
            } else {
                this.isActiveKeyup = true
                this.previousPassword = value
            }
        }
    },
    methods: {
        menuDown(event) {
            this.$router.push(event)
        },
        forgetPassword () {
            this.$router.push('/forgetpassword')
        },
        login () {
            if (this.isActiveKeyup) {
                const request = {
                    UserName: this.UserName,
                    Password: this.Password
                }
                this.$store
                    .dispatch(AUTH_REQUEST, request)
                    // eslint-disable-next-line no-unused-vars
                    .then((response) => {
                        this.canAddListener = false
                        this.$router.push('/')
                        localStorage.setItem('LFCount', 0)
                    })
                    .catch((errorObject) => {
                        this.LoginFailedCount++
                        localStorage.setItem('LFCount', this.LoginFailedCount)
                        this.setCapcthaToken()
                        this.isActiveKeyup = false
                        this.errorMessage = 'Geçersiz Kullanıcı';
                        this.snackbar = true;
                        console.log(errorObject)
                    })
            } else {
                console.log('operation failed')
            }
        },
        setCapcthaToken: function () {
            this.recaptchaToken = ''
            this.enteredCapctha = ''
            var characters =
                'ABCDEFGHJKLMNOPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz0123456789'
            for (let i = 0; i < 6; i++) {
                this.recaptchaToken += characters.charAt(
                    Math.floor(Math.random() * characters.length)
                )
            }
        },
        onCheckRemember: function () {
            if (
                this.$refs.checkboxComponentRef.data === true &&
                this.UserName != null
            ) {
                localStorage.setItem('UserName', this.UserName)
                localStorage.setItem('RememberMe', this.$refs.checkboxComponentRef.data)
            } else {
                localStorage.removeItem('UserName')
                localStorage.removeItem('RememberMe')
            }
        }
    }
}
</script>

<style scoped>
.login-container {
    height: 100vh;
    width: 100vw;
    position: relative;
}

.login-card {
    margin-left: 195px;
    position: absolute;
    left: 0;
    top: 50%;
    transform: translateY(-50%);
    width: 365px;
    height: 450px;
    background: #FFFFFF;
    box-shadow: 0px 4px 44px rgba(0, 0, 0, 0.25);
    border-radius: 20px;
    padding: 29px 30px;
}

.login-container .v-card-text {
    flex: 1 1 auto;
    font-size: 0.875rem;
    font-weight: 400;
    letter-spacing: 0.0178571429em;
    padding: 0px !important;
    text-transform: none;
    text-align: left;
}

.login-container .v-card-title {
    margin-top: 5px;
    text-align: left;
    font-style: normal;
    font-weight: 600;
    font-size: 18px;
    color: #000000;
}
</style>

  